__author__ = 'alvinhkh'

import rumps
from threading import Thread, Timer
from Tkinter import *
import subprocess
import os
import shelve


class FTPSync(rumps.App):
    def __init__(self):
        super(FTPSync, self).__init__("ftpSync")
        self.menu_schedule = rumps.MenuItem("Schedule Sync", callback=self.schedule_sync)
        self.menu = ["Window", "Sync Now", self.menu_schedule, "Preferences"]

        self.ftps_connect = False
        self.sync_schedule = False
        self.sync_interval = 5
        self.get_preference()

        if self.sync_schedule:
            t = Timer(1, self.run_schedule)
            t.start()
        else:
            t = Timer(1, self.run_check_ftps)
            t.start()

    @rumps.clicked("Preferences")
    def preferences(self, _):
        # rumps.alert("jk! no preferences available!")
        # rumps.Window("I can't think of a good example app...").run()
        subprocess.call([sys.executable, os.path.join('.', 'PreferenceFrame.py')])
        self.get_preference()

    @rumps.clicked("Window")
    def window(self, _):
        subprocess.call([sys.executable, os.path.join('.', 'WindowFrame.py')])

    @rumps.clicked("Sync Now")
    def sync(self, _):
        t = Thread(target=self.run_sync)
        t.start()

    @rumps.clicked("Schedule Sync")
    def schedule_sync(self, sender):
        sender.state = not sender.state
        self.sync_schedule = sender.state
        status_text = 'On' if self.sync_schedule else 'Off'
        rumps.notification("ftpSync", "Schedule Sync is " + status_text, "Sync every " + str(self.sync_interval) + " minutes")
        t = Thread(target=self.run_schedule)
        t.start()

    def run_sync(self):
        import Sync
        if self.ftps_connect:
            self.title = "Syncing"
            # rumps.notification("ftpSync", "Sync", "Started")
            Sync.run_sync()
        else:
            self.run_check_ftps()
            if self.ftps_connect:
                self.title = "Syncing"
                Sync.run_sync()
                # subprocess.call([sys.executable, os.path.join('.', 'SolveConflicts.py')])
                rumps.notification("ftpSync", "Sync", "Finished")
                self.title = "ftpSync"
            else:
                rumps.notification("ftpSync", "Sync", "Failed")
                self.title = "Sync Fail"

    def run_schedule(self):
        import time
        while self.sync_schedule:
            self.title = "ftpSync"
            self.get_preference()
            self.run_sync()
            time.sleep(self.sync_interval * 60)

    def run_check_ftps(self):
        print "Checking server.."
        self.title = "Checking.."
        from FTPUtils import FTPUtils
        ftps = FTPUtils()
        connect = ftps.connect()
        if connect['error']:
            error_message = "Fail to connect server"
            if 'message' in connect:
                error_message = str(connect['message'])
            rumps.notification("ftpSync", "", error_message)
            self.ftps_connect = False
        else:
            self.ftps_connect = True
        self.title = "ftpSync"

    def get_preference(self):
        pref_db = shelve.open('ftpsync_preference.db')
        preferences = {}
        if 'preferences' in pref_db:
            preferences = dict(pref_db['preferences'])
        if 'sync_schedule' in preferences:
            self.sync_schedule = preferences['sync_schedule']
        self.menu_schedule.state = self.sync_schedule
        if 'sync_interval' in preferences and int(preferences['sync_interval']) > 0:
            self.sync_interval = int(preferences['sync_interval'])
        pref_db.close()

if __name__ == "__main__":
    FTPSync().run()