__author__ = 'alvinhkh'

from Tkinter import *
import tkMessageBox

from FTPUtils import *
from threading import Thread
import shelve

class ViewSelectionFrame(Frame):
    # GUI Setup
    def __init__(self, parent, root):
        # initialise ViewSelectionFrame Class
        Frame.__init__(self, parent)
        self.parent = parent
        self.root = root

        self.sync_path = []

    def heading(self):
        # Set Heading from root frame to display
        return "View Selected Directories"

    def refresh(self, **kwargs):
        for widget in self.winfo_children():
            widget.destroy()
        db = shelve.open('ftpsync_dir.db')
        db_count = len(db)
        self.sync_path = []
        if 'sync_path' in db:
            self.sync_path = db['sync_path']
        db.close()
        self.populate()

    def populate(self):
        self.grid()
        self.grid_rowconfigure(2, weight=1)
        self.grid_columnconfigure(1, weight=1)

        button_frame = Frame(self)
        button_frame.grid(row=0, column=0, sticky=N+S+E+W)

        log_button = Button(button_frame, text='Back to Log', font=('MS', 12, 'bold'), command=self.action_show_log)
        log_button.grid(row=0, column=0, sticky=N+S)
        add_button = Button(button_frame, text='Add', font=('MS', 12, 'bold'), command=self.action_add)
        add_button.grid(row=0, column=1, sticky=N+S)

        content_frame = Frame(self)
        content_frame.grid(row=1, column=0, sticky=N+S+E+W)

        i = 2
        for j, path in enumerate(self.sync_path):
            delete_button = Button(content_frame, text='X', font=('MS', 8, 'bold'),
                                   command=lambda path=path: self.action_delete(path))
            delete_button.grid(row=i, rowspan=2, column=0, sticky=N+S+W)
            edit_button = Button(content_frame, text='edit', font=('MS', 8, 'bold'),
                                 command=lambda path=path: self.action_edit(path))
            edit_button.grid(row=i, rowspan=2, column=8, sticky=N+S+W)
            local_path_label = Label(content_frame, text='Local: ', font=('MS', 12, 'bold'))
            local_path_label.grid(row=i, column=1, sticky=E)
            local_path_value = Label(content_frame, text=path['local'], font=('MS', 12), justify=LEFT, wraplengt=300)
            local_path_value.grid(row=i, column=2, columnspan=5, sticky=W)
            i += 1
            remote_path_label = Label(content_frame, text='Remote: ', font=('MS', 12, 'bold'))
            remote_path_label.grid(row=i, column=1, sticky=E)
            remote_path_value = Label(content_frame, text=path['remote'], font=('MS', 12), justify=LEFT, wraplengt=300)
            remote_path_value.grid(row=i, column=2, columnspan=5, sticky=W)
            i += 1

    def action_add(self):
        self.root.show_frame("add_selection")

    def action_delete(self, path):
        db = shelve.open('ftpsync_dir.db')
        db_count = len(db)
        if 'sync_path' in db:
            sync_path = db['sync_path']
        else:
            sync_path = []
        if path in sync_path:
            sync_path.remove(path)
        db['sync_path'] = sync_path
        db.close()
        self.refresh()

    def action_edit(self, path):
        self.root.show_frame("add_selection", local_path=path['local'], remote_path=path['remote'])

    def action_show_log(self):
        self.root.show_frame("view_log")